<?php

namespace Drupal\synpay\Form;

use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Form\FormBase;

/**
 * Configure zakaz settings for this site.
 */
class PayForm extends FormBase {

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'synpay_pay';
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state, $extra = NULL) {
    $plugin = $extra;
    $form_state->set('paymentPlugin', $plugin);
    $form['order'] = [
      '#type' => 'textfield',
      '#title' => $this->t('Order number'),
      '#default_value' => $plugin->order,
    ];
    $form['order']['#attributes'] = ['readonly' => 'readonly'];
    $form['total'] = [
      '#type' => 'textfield',
      '#title' => $this->t('Order total'),
      '#default_value' => $plugin->total,
    ];
    $form['btn'] = [
      '#type' => 'submit',
      '#value' => $this->t('Submit payment'),
      '#attributes' => [
        'class' => [
          'btn',
          'btn-warning',
        ],
      ],
    ];
    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function validateForm(array &$form, FormStateInterface $form_state) {
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    $plugin = $form_state->get('paymentPlugin');
    $total = $form_state->getValue('total');
    $order = $form_state->getValue('order');
    $plugin->pay($order, $total);
  }

}
